import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.util.*;
import java.sql.*;
import java.text.*;

/**
 * View principal de la aplicacion
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class AppView extends WindowAdapter {
    private JFrame fr = new JFrame("SISTEMA FACTURACION");
    private JMenuBar mb = new JMenuBar();
    private JMenu mcli = new JMenu("Cliente");
    private JMenu mpro = new JMenu("Producto");
    private JMenu mfac = new JMenu("Factura");
    private JMenuItem micli1 = new JMenuItem("Alta");
    private JMenuItem micli2 = new JMenuItem("Consulta 1");
    private JMenuItem micli3 = new JMenuItem("Consulta 2");
    private JMenuItem micli4 = new JMenuItem("Consulta 3");
    private JMenuItem mipro1 = new JMenuItem("Alta");
    private JMenuItem mifac1 = new JMenuItem("Nueva Factura");
    private Login log = null;
    private JPanel pNorth = new JPanel();
    private JPanel pSouth = new JPanel();
    private JPanel pEast = new JPanel();
    private JPanel pWest = new JPanel();
    private JPanel pCenter = new JPanel();
    

    /**
     * Constructor for objects of class AppView
     */
    public AppView() {
    }
    public AppView(Login l) {
        log = l;
        //
        // agrego menu items a menues
        mcli.add(micli1);
        mcli.add(micli2);
        mcli.add(micli3);
        mcli.add(micli4);
        mpro.add(mipro1);
        mfac.add(mifac1);
        // agrego menues a menu bar
        mb.add(mcli);
        mb.add(mpro);
        mb.add(mfac);
        fr.getContentPane().add("North",pNorth);
        fr.getContentPane().add("South",pSouth);
        fr.getContentPane().add("East",pEast);
        fr.getContentPane().add("West",pWest);
        fr.getContentPane().add("Center",pCenter);
        // indico menu del JFrame
        fr.setJMenuBar(mb);
        
        // initialise instance variables
        fr.addWindowListener(this);
        micli1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("presiono alta de cliente!");
                removeComponent();
                JTextField txtCodigo = new JTextField("");
                JTextField txtDescr = new JTextField("");
                JTextField txtSaldo = new JTextField("0.0");
                JLabel lblCodigo = new JLabel("Codigo");
                JLabel lblDescr = new JLabel("Descripcion");
                JLabel lblSaldo = new JLabel("Saldo");
                JButton btn = new JButton("Grabar");
                JPanel pfrm = new JPanel(new SpringLayout());
                lblCodigo.setLabelFor(txtCodigo);
                lblDescr.setLabelFor(txtDescr);
                lblSaldo.setLabelFor(txtSaldo);
                pfrm.add(lblCodigo);
                pfrm.add(txtCodigo);
                pfrm.add(lblDescr);
                pfrm.add(txtDescr);
                pfrm.add(lblSaldo);
                pfrm.add(txtSaldo);
                pfrm.add(new JLabel(""));
                pfrm.add(btn);

                //
                txtCodigo.setEnabled(false);
                try {
                    ResultSet rs = DataIO.getResultSet("SELECT COALESCE(MAX(IDC)+1,1) FROM TBL_CLIENTE");
                    if ( rs.next() ) {
                        txtCodigo.setText(rs.getString(1));
                    }
                    rs.close();
                } catch(SQLException sqle) {
                    txtCodigo.setText("1");
                }
                
                // events
                btn.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        //validar
                        if ( txtDescr.getText().length() < 1 ) {
                            JOptionPane.showMessageDialog(null, "Debe Ingresar una descripcion", "Error de Validacion", JOptionPane.ERROR_MESSAGE);
                            txtDescr.requestFocus();
                            return;
                        }
                        try {
                            Double d = new Double(txtSaldo.getText());
                            if ( d < 0 ) {
                                JOptionPane.showMessageDialog(null, "Debe Ingresar un saldo mayor que cero", "Error de Validacion", JOptionPane.ERROR_MESSAGE);
                                txtSaldo.requestFocus();
                                return;
                            }
                        }catch(NumberFormatException nfe) {
                            JOptionPane.showMessageDialog(null, "["+txtSaldo.getText()+"] no es un numero!", "Error de Validacion", JOptionPane.ERROR_MESSAGE);
                            txtSaldo.requestFocus();
                            return;
                        }
                        //insertar cliente en b.d.
                        
                        if ( DataIO.executeQuery("INSERT INTO TBL_CLIENTE(IDC,DESCR,SALDO) VALUES("+txtCodigo.getText()+",'"+txtDescr.getText()+"',"+txtSaldo.getText()+")") ) {
                            DataIO.doCommit();
                            JOptionPane.showMessageDialog(null, "Cliente dado de Alta Ok!", "Info", JOptionPane.INFORMATION_MESSAGE);
                        } else {
                            JOptionPane.showMessageDialog(null, "Error ["+DataIO.getErrorMessages()+"] al intentar dar de alta Cliente!", "Error BD", JOptionPane.ERROR_MESSAGE);
                        }
                    }
                });
                
                //Lay out the panel.
                SpringUtilities.makeCompactGrid(pfrm,
                                                4, 2, //rows, cols
                                                6, 6, //initX, initY
                                                6, 6);//xPad, yPad
                                                
                pCenter.add(pfrm);
                refresh();
            }
        });

/**
 * Opcion de consulta 1 consulta muy basica sobre cliente
 */
        micli2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("presiono consulta 1 de cliente!");
                removeComponent();
                JTable tbl = new JTable();
                ResultSet rs = DataIO.getResultSet("SELECT * FROM TBL_CLIENTE");
/***********************************************************************************
 *               EJEMPLO BASICO CON CLASE ANONIMA
 ***********************************************************************************                
                tbl.setModel(new AbstractTableModel() {
                    private ResultSet rs = null;
                    public int getRowCount() {
                        return 2;
                    }
                    public int getColumnCount() {
                        return 3;
                    }
                    public Object getValueAt(int row, int column) {
                        return ""+row+","+column;
                    }
                });
***********************************************************************************                                
*/                
                ClienteModel tblm = new ClienteModel(rs);
                tbl.setModel(tblm);
                pCenter.add(tbl);
                refresh();
            }
        });
/**
 * Opcion de consulta 2 que permite hacer abm simple sobre grilla y base de datos
 */
        micli3.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("presiono consulta 2 de cliente!");
                removeComponent();
                JPanel pEste = new JPanel();
                JTable tbl = new JTable();
                JButton btnAlta = new JButton("Alta");
                JButton btnBaja = new JButton("Baja");
                JScrollPane scp = new JScrollPane(tbl,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
                ResultSet rs = DataIO.getResultSet("SELECT * FROM TBL_CLIENTE");
                ClienteModel2 tblm = new ClienteModel2(rs);
                tbl.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
                tbl.setModel(tblm);
                pEste.setLayout(new GridLayout(5,1));
                pEste.add(new JLabel(""));
                pEste.add(btnAlta);
                pEste.add(new JLabel(""));
                pEste.add(btnBaja);
                pCenter.add(scp);
                pEast.add(pEste);
                
                // agregar eventos
                btnAlta.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        tblm.agregar();
                    }
                });
                btnBaja.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        if ( tbl.getSelectedRow() != -1 ) {
                            tblm.borrar(tbl.getSelectedRow());
                        }
                    }
                });
                refresh();
            }
        });
        
/**
 * Opcion de consulta 3 que permite hacer abm simple sobre grilla y base de datos
 */
        micli4.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("presiono consulta 3 de cliente!");
                removeComponent();
                JPanel pEste = new JPanel();
                JTable tbl = new JTable();
                JButton btnAlta = new JButton("Alta");
                JButton btnBaja = new JButton("Baja");
                JButton btnGuardar = new JButton("Guardar");
                JScrollPane scp = new JScrollPane(tbl,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
                ResultSet rs = DataIO.getResultSet("SELECT * FROM TBL_CLIENTE");
                ClienteModel3 tblm = new ClienteModel3(rs);
                tbl.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
                tbl.setModel(tblm);
                btnGuardar.setEnabled(false);
                pEste.setLayout(new GridLayout(7,1));
                pEste.add(new JLabel(""));
                pEste.add(btnAlta);
                pEste.add(new JLabel(""));
                pEste.add(btnGuardar);
                pEste.add(new JLabel(""));
                pEste.add(btnBaja);
                pEste.add(new JLabel(""));
                pCenter.add(scp);
                pEast.add(pEste);
                
                // agregar eventos
                btnAlta.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        tblm.agregar(btnAlta,btnBaja,btnGuardar);
                    }
                });
                btnBaja.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        if ( tbl.getSelectedRow() != -1 ) {
                            tblm.borrar(tbl.getSelectedRow());
                        }
                    }
                });
                btnGuardar.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        tblm.guardar();
                    }
                });
                refresh();
            }
        });
/**
 * Opcion de nueva factura
 */
        mifac1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                removeComponent();
                JPanel pEste = new JPanel();
                JPanel pSur = new JPanel(new SpringLayout());
                JComboBox<Producto> cp = new JComboBox<Producto>();
                JComboBox<Cliente> cc = new JComboBox<Cliente>();
                JFormattedTextField txtTotal = new JFormattedTextField(new DecimalFormat("###,###,###,##0.00"));
                txtTotal.setEditable(false);
                txtTotal.setValue(new Double(0.0));
                txtTotal.setPreferredSize(new Dimension(200,20));
                txtTotal.setHorizontalAlignment(SwingConstants.RIGHT); // alinear a la derecha
                txtTotal.setFont(new Font(null,Font.BOLD,12)); // font x defecto, en bold, y 12 pixels
                JTable tbl = new JTable();
                tbl.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
                DetalleModel dm = new DetalleModel(txtTotal);
                dm.agregar();
                tbl.setModel(dm);
                tbl.setRowHeight(20);  // alto en pixel para todas las celdas, para que se visualice mejor la jcombobox
                TableColumn colpr = tbl.getColumnModel().getColumn(0);
                colpr.setCellEditor(new DefaultCellEditor(cp));
                colpr.setMinWidth(100);
                colpr.setMaxWidth(300);
                colpr.setWidth(300);
                colpr.setPreferredWidth(300);
                tbl.getColumnModel().getColumn(1).setMinWidth(50);
                tbl.getColumnModel().getColumn(1).setMaxWidth(100);
                tbl.getColumnModel().getColumn(1).setWidth(50);
                tbl.getColumnModel().getColumn(1).setPreferredWidth(75);
                tbl.getColumnModel().getColumn(2).setMinWidth(50);
                tbl.getColumnModel().getColumn(2).setMaxWidth(100);
                tbl.getColumnModel().getColumn(2).setWidth(50);
                tbl.getColumnModel().getColumn(2).setPreferredWidth(75);
                tbl.getColumnModel().getColumn(3).setMinWidth(50);
                tbl.getColumnModel().getColumn(3).setMaxWidth(100);
                tbl.getColumnModel().getColumn(3).setWidth(50);
                tbl.getColumnModel().getColumn(3).setPreferredWidth(75);
                //colpr.setMaxWidth(colpr.getMaxWidth()*2);
                //DefaultTableCellRenderer renderer = new DefaultTableCellRenderer();
                //renderer.setToolTipText("Click for combo box");
                //colpr.setCellRenderer(renderer);                
                JButton btnAlta = new JButton("+");
                JButton btnBaja = new JButton("-");
                JButton btnGuardar = new JButton("Confirmar");
                JScrollPane scp = new JScrollPane(tbl,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
                scp.setPreferredSize(new Dimension(600,600));
                //fr.setSize(800,800);
                
                ResultSet rs = DataIO.getResultSet("SELECT * FROM TBL_PRODUCTO ORDER BY DESCR ASC");
                java.util.List<Producto> lst = new ArrayList<Producto>();
                java.util.List<Cliente> lstc = new ArrayList<Cliente>();
                try {
                    // cargo lista de Productos
                    while(rs.next()) {
                        lst.add(new Producto(rs.getInt("idp"),rs.getString("descr"),rs.getDouble("precio_base"),rs.getInt("stock")));
                    }
                    rs.close();
                    // cargo lista de Clientes
                    rs = DataIO.getResultSet("SELECT * FROM TBL_CLIENTE ORDER BY DESCR ASC");
                    while(rs.next()) {
                        lstc.add(new Cliente(rs.getInt("idc"),rs.getString("descr"),rs.getDouble("saldo")));
                    }
                    rs.close();
                } catch(SQLException sqle) {
                    System.err.println("ProductoComboModel(): Error "+sqle.getMessage());
                }
                MyComboModel<Producto> pm = new MyComboModel<Producto>(lst);
                MyComboModel<Cliente> cm = new MyComboModel<Cliente>(lstc);
                /*
                java.util.List<MyComboModel<Producto>> pms = new ArrayList<MyComboModel<Producto>>();
                java.util.List<JComboBox<Producto>> cps = new ArrayList<JComboBox<Producto>>();
                for(int i=0;i<100;i++) {
                    pms.add(new MyComboModel<Producto>(lst));
                    cps.add(new JComboBox<Producto>());
                    cps.get(i).setModel(pms.get(i));
                }
                */
                MyComboBoxRenderer<Producto> cbr = new MyComboBoxRenderer<Producto>(lst);
                colpr.setCellRenderer(cbr);
                cp.setModel(pm);
                cc.setModel(cm);
                tbl.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
                //tbl.setModel(tblm);
                pEste.setLayout(new GridLayout(7,1));
                pSur.add(new JLabel("Total:"));
                pSur.add(txtTotal);
                pSur.add(btnGuardar);
                //Lay out the panel.
                SpringUtilities.makeCompactGrid(pSur,
                                                1, 3, //rows, cols
                                                6, 6, //initX, initY
                                                6, 6);//xPad, yPad
                pEste.add(new JLabel(""));
                pEste.add(btnAlta);
                pEste.add(new JLabel(""));
                pEste.add(new JLabel(""));
                pEste.add(btnBaja);
                pEste.add(new JLabel(""));
                //pCenter.add(scp);
                pCenter.add(scp);
                pEast.add(pEste);
                pSouth.add(pSur);
                
                // agregar eventos
                btnAlta.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        //tblm.agregar(btnAlta,btnBaja,btnGuardar);
                        dm.agregar();
                    }
                });
                btnBaja.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        if ( tbl.getSelectedRow() != -1 ) {
                            //tblm.borrar(tbl.getSelectedRow());
                            dm.borrar(tbl.getSelectedRow());
                        }
                    }
                });
                btnGuardar.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        // validar
                        Set<Producto> sp = new TreeSet<Producto>();
                        boolean ok=true;
                        for(Detalle d:dm.getDetalle()) {
                            if ( d.getProducto() != null ) {
                                if ( !sp.contains(d.getProducto()) ) {
                                    sp.add(d.getProducto());
                                } else {
                                    JOptionPane.showMessageDialog(null, "El producto ["+d.getProducto().getDescripcion()+"] ya esta en esta factura, no puede repetirlo!", "Error de Validacion", JOptionPane.ERROR_MESSAGE);
                                    ok=false;
                                    break;
                                }
                            }
                        }
                        if ( ok ) {
                            JOptionPane.showMessageDialog(null, "Agrego factura!", "Error de Validacion", JOptionPane.INFORMATION_MESSAGE);
                        }
                    }
                });
                cc.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        //tblm.guardar();
                        int i = cc.getSelectedIndex();
                        if ( i != -1 ) {
                            Cliente c = lstc.get(i);
                            System.out.println("AppView.main(): Selecciono Cliente: "+c);
                        }
                        
                    }
                });
                cp.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        //tblm.guardar();
                        int i = cp.getSelectedIndex();
                        if ( i != -1 ) {
                            Producto p = lst.get(i);
                            System.out.println("AppView.main(): Selecciono Producto: "+p);
                        }
                        
                    }
                });
                refresh();
            }
        });
        
        fr.setLocationRelativeTo(null); // centrado
        // PASO 7 CONFIGURAR EL TAMA#O DEL CONTENEDOR
        fr.setSize(500,400);
        // PASO 8 HACER EL CONTENEDOR VISIBLE
        fr.setVisible(true);
    }
    
    // windows events que nos interesan
    // sobre-escribo metodo windowClosed()
    @Override
    public void windowClosing(WindowEvent e) {
         log.cierroAplicacion();
    }

    private void removeComponent() {
        pNorth.removeAll();
        pSouth.removeAll();
        pEast.removeAll();
        pWest.removeAll();
        pCenter.removeAll();
    }
    private void refresh() {
        // refresh
        fr.pack();
        fr.invalidate();
        fr.validate();
    }
}
